
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "QmfPackage.h"
#include <qmf/Schema.h>
#include <qmf/SchemaProperty.h>
#include <qmf/SchemaMethod.h>
#include <string>

using namespace std;
using namespace qmf::org::matahariproject;

void PackageDefinition::configure(::qmf::AgentSession& session)
{
    string package("org.matahariproject");

    //
    // Data: Network
    //
    data_Network = qmf::Schema(SCHEMA_TYPE_DATA, package, "Network");
    {
        qmf::SchemaProperty prop("uuid", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("Host UUID");
        data_Network.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("hostname", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setIndex(true);
        prop.setDesc("Hostname");
        data_Network.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("qmf-gen-no-crash", qmf::SCHEMA_DATA_INT);
        prop.setSubtype("abstime");
        prop.setDesc("Dummy stat to stop qmf-gen from crashing.");
        data_Network.addProperty(prop);
    }

    {
        qmf::SchemaMethod method("list");
        method.setDesc("List IP addresses");
        {
            qmf::SchemaProperty arg("iface_map", qmf::SCHEMA_DATA_LIST);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Network.addMethod(method);
    }

    {
        qmf::SchemaMethod method("start");
        method.setDesc("Start a network interface");
        {
            qmf::SchemaProperty arg("iface", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("status", qmf::SCHEMA_DATA_INT);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Network.addMethod(method);
    }

    {
        qmf::SchemaMethod method("stop");
        method.setDesc("Stop a network interface");
        {
            qmf::SchemaProperty arg("iface", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("status", qmf::SCHEMA_DATA_INT);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Network.addMethod(method);
    }

    {
        qmf::SchemaMethod method("status");
        method.setDesc("Check a network interface");
        {
            qmf::SchemaProperty arg("iface", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("status", qmf::SCHEMA_DATA_INT);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Network.addMethod(method);
    }

    {
        qmf::SchemaMethod method("get_ip_address");
        method.setDesc("Obtain ip addressof a network interface");
        {
            qmf::SchemaProperty arg("iface", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("ip", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Network.addMethod(method);
    }

    {
        qmf::SchemaMethod method("get_mac_address");
        method.setDesc("Obtain mac address of network interface");
        {
            qmf::SchemaProperty arg("iface", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("mac", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Network.addMethod(method);
    }

    session.registerSchema(data_Network);

}

